/* RSS2BIN.C   (v1.2) Alexander A. Shabarshin  10.11.2000 */
/* RSS2BIN.CPP (v1.1) Alexander A. Shabarshin  14.04.1999 */
/* RSS2BIN.CPP (v1.0) Alexander A. Shabarshin  21.03.1999 */
/*                                                        */
/* ८ࠧ⥫ 䠩 ଠ RSS  BIN 64K           */
/*   뢮  樮  */
/*                                                        */
/*  묨 ⠭묨 ANSI-C ࠬ */
/*                                                        */
/* BORLAND C++ 3.1,  WATCOM-C/C++ 10.0,  VISUAL-C++ 4.2,  */
/* PACIFIC C 7.51 (HI-TECH SOFTWARE)                      */

/*
     ଠ 䠩 ᭠ (.RSS)  ᯮ짮    
                        8080 (58080)
===========================================================================
...
᫨    3  ⮢,   
᫥騬 ࠧ: 0CBH <騩 > <稪 ஢>.
===========================================================================
   . 宭
   04.03.99.                               mailto:pyva@uic.nnov.ru
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define EM_BYTE unsigned char
#define EM_UINT unsigned short

#define EBIN ".bin"
#define ERSS ".rss"

#define SIZE4 16384

#pragma pack(1)

/*   */

typedef struct tagHEAD_PROC
{
 char sign[4]; /* 'RKSS' - ᨣ (RK SnapShot) */
 EM_BYTE comp; /*   */
 EM_UINT pc;   /* PC */
 EM_UINT bc;   /* BC */
 EM_UINT de;   /* DE */
 EM_UINT hl;   /* HL */
 EM_UINT af;   /* AF */
 EM_UINT sp;   /* SP */
 EM_BYTE inte; /* Interrupt flag (0-off,  0 - on) */
}HEAD_PROC;

#define RKSS "RKSS"

/*   */

#define MC_RK 0x00  /* -86      */
#define MC_MI 0x01  /*     */
#define MC_PA 0x02  /* ⭥    */
#define MC_AP 0x03  /*      */
#define MC_SP 0x04  /* 樠 */
#define MC_OR 0x05  /* ਮ      */
#define MC_80 0x06  /* -80   */
#define MC_UT 0x07  /* -88      */

/*   */

typedef struct tagHEAD_COMP
{
 EM_UINT len;     /*  筮  */
 EM_BYTE mon;     /*   */
 EM_UINT scr;     /* 砫 ࠭  (76D0H) */
 EM_UINT scl;     /*  ࠭  (2340) */
 EM_BYTE row;     /* ⢮ ப (30) */
 EM_BYTE col;     /* ⢮ ⮫殢 (78) */
 EM_BYTE ppa;     /* 4    C  (0) */
 EM_BYTE xcu;     /*   X  */
 EM_BYTE ycu;     /*   Y  */
 EM_BYTE *op;     /* 樮 ࠬ */
}HEAD_COMP;

#define OPOFF 12  /* 饭  樮 ࠬ஢ */

/*   */

typedef struct tagHEAD_EMUL
{
 char sign[4]; /*   */
 EM_UINT len;  /*    */
 EM_BYTE *add; /* ᪨    (⥪. ०) */
}HEAD_EMUL;

#define EM80 "EM80"

/*   */

typedef struct tagHEAD_BLOK
{
 EM_BYTE type;  /*  ᨨ (0-, 1- ᨥ) */
 EM_UINT len;   /*   ( ⨬ ) */
 EM_UINT adr;   /*  砫 */
 EM_UINT siz;   /*  ᦠ  */
 EM_BYTE *data; /*  */
}HEAD_BLOK;

#define CODE 0xCB

char* readheadproc ( FILE *f, HEAD_PROC *h )
{
  int i;
  char s[5];
  static char model[16];
  strcpy(s,RKSS);
  fread(h,sizeof(HEAD_PROC),1,f);
  for(i=0;i<4;i++) if(h->sign[i]!=s[i]) return NULL;
  switch(h->comp)
  {
    case MC_RK: strcpy(model,"-86"); break;
    case MC_MI: strcpy(model,""); break;
    case MC_PA: strcpy(model,"⭥"); break;
    case MC_AP: strcpy(model,""); break;
    case MC_SP: strcpy(model,"樠"); break;
    case MC_OR: strcpy(model,"ਮ"); break;
    case MC_80: strcpy(model,"-80"); break;
    case MC_UT: strcpy(model,"-88"); break;
    default: strcpy(model,""); break;
  }
  return model;
}

int readheadcomp ( FILE *f, HEAD_COMP *h )
{
  int len;
  memset(h,0,sizeof(HEAD_COMP));
  fread(h,1,2,f);
  h->op = NULL;
  len = *((EM_UINT*)h);
  if(len>OPOFF)
  {
     fread(&h->mon,1,OPOFF-2,f);
     h->op = (EM_BYTE*)malloc(len-OPOFF);
     if(h->op==NULL) return 0;
     fread(h->op,1,len-OPOFF,f);
  }
  else fread(&h->mon,1,len-2,f);
  return 1;
}

int readheademul ( FILE *f, HEAD_EMUL *h )
{
  h->add = NULL;
  fread(h,6,1,f);
  if(h->len>6)
  {
     h->add = (EM_BYTE*)malloc(h->len-6);
     if(h->add==NULL) return 0;
     fread(h->add,(h->len)-6,1,f);
  }
  return 1;
}

int readheadblok ( FILE *f, HEAD_BLOK *h )
{
  int i,j,k,n,ok=0;
  fread(h,7,1,f);
  h->data = (EM_BYTE*)malloc(h->siz);
  if(h->data==NULL) return 0;
  if(h->type==0)
  {
    if(h->len-7!=h->siz) return 0;
    fread(h->data,h->siz,1,f);
    ok = 1;
  }
  if(h->type==1)
  {
    i = 0;
    while(i<h->siz)
    {
      k = fgetc(f);
      if(k==CODE)
      {
         k = fgetc(f);
         n = fgetc(f);
         for(j=0;j<n;j++) h->data[i+j]=k;
         i += n;
      }
      else
      {
         h->data[i] = k;
         i++;
      }
    }
    ok = 1;
  }
  if(!ok) return 0;
  return 1;
}

EM_BYTE *mem[4];
EM_BYTE mode = 0;

EM_BYTE getmemo(long adr){return mem[adr>>14][adr&0x3FFF];}
void setmemo(long adr,EM_BYTE b){mem[adr>>14][adr&0x3FFF]=b;}

int main(int argc,char **argv)
{
 int i,j,k;
 unsigned short us;
 FILE *f1,*f2;
 char str1[100],str2[100],*mod,*po;
 HEAD_PROC hp;
 HEAD_COMP hc;
 HEAD_EMUL he;
 HEAD_BLOK hb;

 printf("\nRSS -> BIN  Decoder\n");
 printf("Copyright (c) 1999-2000, Alexander Shabarshin (shaos@mail.ru)\n");
 printf("RSS-format - Victor Pykhonin (pyva@uic.nnov.ru)\n\n");
 if(argc<2)
 {
   printf("Usage:   RSS2BIN file.rss\n\n");
   return 0;
 }
 for(i=0;i<4;i++)
 {
    mem[i] = (EM_BYTE*)malloc(SIZE4);
    if(mem[i]==NULL) return 0;
    memset(mem[i],0,SIZE4);
 }
 strcpy(str1,argv[1]);
 po = strrchr(str1,'.');
 if(po!=NULL) *po=0;
 strcpy(str2,str1);
 strcat(str1,ERSS);
 strcat(str2,EBIN);
 f1 = fopen(str1,"rb");
 if(f1==NULL)
 {
    printf("File open error <%s>\n",str1);
    return 0;
 }
 f2 = fopen(str2,"wb");
 if(f2==NULL)
 {
    printf("File open error <%s>\n",str2);
    return 0;
 }
 he.add = NULL;
 hb.data = NULL;

 printf(" :\n");
 mod = readheadproc(f1,&hp);
 if(mod==NULL) return 0;
 printf("%c%c%c%c ⨯ : %s\n",hp.sign[0],hp.sign[1],
                        hp.sign[2],hp.sign[3],mod);
 printf("PC=%4.4X SP=%4.4X ",hp.pc,hp.sp);
 printf("AF=%4.4X BC=%4.4X ",hp.af,hp.bc);
 printf("DE=%4.4X HL=%4.4X ",hp.de,hp.hl);
 printf("\ninterrupt %d\n\n",hp.inte);

 printf(" :\n");
 if(!readheadcomp(f1,&hc)) return 0;
 printf("  %d\n",hc.len);
 printf("  %d\n",hc.mon);
 printf("砫 ࠭  %4.4XH\n",hc.scr);
 printf(" ࠭  %d\n",hc.scl);
 printf("⢮ ப %d\n",hc.row);
 printf("⢮ ⮫殢 %d\n",hc.col);
 printf("4    C  %2.2XH\n",hc.ppa);
 printf("  X  %d\n",hc.xcu);
 printf("  Y  %d\n",hc.ycu);
 printf("樮 ࠬ (%d ):\n",hc.len-OPOFF);
 for(i=OPOFF;i<hc.len;i++)
 {
    printf(" %2.2X",hc.op[i-OPOFF]);
    if(((i-OPOFF)%16)==15) printf("\n");
 }
 if(i>OPOFF) printf("\n");
 printf("\n");

 printf(" :\n");
 if(!readheademul(f1,&he)) return 0;
 printf("%c%c%c%c   %d\n",
        he.sign[0],he.sign[1],he.sign[2],he.sign[3],he.len);
 if(he.add!=NULL)
 {
    printf("⥫  (%d ): ",he.len-6);
    for(i=0;i<he.len-6;i++) printf("%2.2X ",he.add[i]);
    printf("\n");
 }
 printf("\n");

 k = fgetc(f1); /* ⢮   */
 printf(" (⢮  %d) :\n",k);
 for(i=0;i<k;i++)
 {
    if(!readheadblok(f1,&hb)) return 0;
    printf(" %d\t( %d)\t",i,hb.type);
    printf(" 砫 %4.4X,  %u (%4.4XH)\n",hb.adr,hb.siz,hb.siz);
    for(us=0;us<hb.siz;us++) setmemo(hb.adr+us,hb.data[us]);
    free(hb.data);
 }
 for(j=0;j<4;j++) fwrite(mem[j],1,SIZE4,f2);

 if(he.add!=NULL) free(he.add);
 if(hc.op!=NULL) free(hc.op);

 return 1;
}
